instrument for valgrind
[flac.git] / test / test_bins.sh
1 #!/bin/sh
2
3 #  FLAC - Free Lossless Audio Codec
4 #  Copyright (C) 2001,2002  Josh Coalson
5 #
6 #  This program is part of FLAC; you can redistribute it and/or
7 #  modify it under the terms of the GNU General Public License
8 #  as published by the Free Software Foundation; either version 2
9 #  of the License, or (at your option) any later version.
10 #
11 #  This program is distributed in the hope that it will be useful,
12 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
13 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 #  GNU General Public License for more details.
15 #
16 #  You should have received a copy of the GNU General Public License
17 #  along with this program; if not, write to the Free Software
18 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
19
20 LD_LIBRARY_PATH=../src/libFLAC/.libs:../obj/release/lib:../obj/debug/lib:$LD_LIBRARY_PATH
21 export LD_LIBRARY_PATH
22 PATH=../src/flac:../obj/release/bin:../obj/debug/bin:$PATH
23 BINS_PATH=../../test_files/bins
24
25 flac --help 1>/dev/null 2>/dev/null || (echo "ERROR can't find flac executable" 1>&2 && exit 1)
26 if [ $? != 0 ] ; then exit 1 ; fi
27
28 run_flac ()
29 {
30         if [ "$FLAC__VALGRIND" = yes ] ; then
31                 valgrind --leak-check=yes --show-reachable=yes --num-callers=10 --logfile-fd=4 flac $* 4>>valgrind.log
32         else
33                 flac $*
34         fi
35 }
36
37 test -d ${BINS_PATH} || exit 77
38
39 test_file ()
40 {
41         name=$1
42         channels=$2
43         bps=$3
44         encode_options="$4"
45
46         echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
47         cmd="run_flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin"
48         echo "### ENCODE $name #######################################################" >> ./streams.log
49         echo "###    cmd=$cmd" >> ./streams.log
50         if $cmd 2>>./streams.log ; then : ; else
51                 echo "ERROR during encode of $name" 1>&2
52                 exit 1
53         fi
54         echo -n "decode..."
55         cmd="run_flac --silent --endian=big --sign=signed --decode --force-raw-format $name.flac";
56         echo "### DECODE $name #######################################################" >> ./streams.log
57         echo "###    cmd=$cmd" >> ./streams.log
58         if $cmd 2>>./streams.log ; then : ; else
59                 echo "ERROR during decode of $name" 1>&2
60                 exit 1
61         fi
62         ls -1l $name.bin >> ./streams.log
63         ls -1l $name.flac >> ./streams.log
64         ls -1l $name.raw >> ./streams.log
65         echo -n "compare..."
66         if cmp $name.bin $name.raw ; then : ; else
67                 echo "ERROR during compare of $name" 1>&2
68                 exit 1
69         fi
70         echo OK
71 }
72
73 echo "Testing bins..."
74 for f in b00 b01 b02 b03 b04 ; do
75         binfile=$BINS_PATH/$f
76         if [ -f $binfile ] ; then
77                 for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
78                         for channels in 1 2 4 8 ; do
79                                 for bps in 8 16 24 ; do
80                                         for opt in 0 1 2 4 5 6 8 ; do
81                                                 for extras in '' '-p' '-e' ; do
82                                                         for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
83                                                                 test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
84                                                         done
85                                                 done
86                                         done
87                                         if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
88                                                 test_file $binfile $channels $bps "-b 16384 -m -r 8 -l 32 -e -p $disable"
89                                         fi
90                                 done
91                         done
92                 done
93         else
94                 echo "$binfile not found, skipping."
95         fi
96 done